#!/bin/sh
# STTA Rev. 1.3 Copyright (c) 2001-2003 Jess Prez Lorenzo  --- license GNU GPL

USAGE="$0 [LANG] [Path origin] [Path to concatenate] [Defs Dir]"
case "$#" in
  0|1|2|3) echo "$USAGE"
      exit 1
      ;;
esac

if [ -z "$STTA" ] ; then
    STTA=`cat /etc/webmin/miniserv.conf 2>$dn | egrep "^root=" | sed 's/root=//g'`/stta
    export STTA
fi

[ -x $STTA/lang/$1.shells ] &&  . $STTA/lang/$1.shells

if [ ! -d $2 ] 
then 
   echo "$msg_notexistdir: $2 "
   exit 1
fi
if [ ! -d $3 ] 
then 
   echo "$msg_notexistdir: $3 "
   exit 1
fi
if [ ! -d $4 ] 
then 
   echo "$msg_notexistdir: $4 "
   exit 1
fi

cd $2 
for nomfile in `ls`
do 
    cat $nomfile | sed "s,DIRDEFS,$4,g" >>$3/$nomfile
    echo "$msg_fixingFile $nomfile "
done
