#!/usr/bin/perl
# log_parser.pl
# Functions for parsing this module's logs
# STTA Rev. 1.2 Copyright (c) Jess Prez Lorenzo  --- license GNU GPL 
# debug=4 is for developers and will dump object-types vars !!!

 $parse_webmin_log=true;
 require 'tarantella-lib.pl';
 
# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
    local ($user, $script, $action, $type, $object, $p) = @_;
    local $cginame=$0;
    local $text_str;
    local $html_str;
    $cginame= $0 =~ /([^\/]+)$/ ? $1 : '-';    
    $debug=4;  # Just uncoment here and bypass $config{debug}
    local %h_obj;
 
    
    if ( ${object} =~ /\|\|/ ) {
         local @obj= split(/\|\|/, ${object}, -1);               
         foreach $item (@obj) {
                 local @objdata= split(/=>/, $item, -1);               
                 if (defined($h_obj{$objdata[0]}) ) {
                     $h_obj{$objdata[0]} .= ", ".$objdata[1];
                 } else {
                     $h_obj{$objdata[0]} = $objdata[1];
                 }
         }
    };
    if ( $cginame eq "view.cgi" ) {
#         $text_str=&text("log_stta", "<tt><b>$texto</b></tt><br>");
         if ($debug gt 1  && %{$p} ) { 
             $html_str=${action};
             if ( ! %h_obj ) { $html_str=" <b>${type}</b> <i>${object}</i>"; }
             $html_str=&html_objlink(${type},$html_str,\%{$p},${action}); 
             $html_str=~s/\0/, /g; #webminlog-lib.pl in &parse_logline
                                   # will add "\0" in a multivalue field
			           # it will crash javascript:window.document.writeln()
         } else {
             $html_str=" ${action}";
             if ( ! %h_obj ) { $html_str.=" <b>${type}</b>"; }
             if ( ! %h_obj ) { $html_str.=" <i>${object}</i>"; }
         }
         if ( %h_obj ) {
#                  &show_hash(\%h_obj,"","=","",\$text_str);
                  $text_str=~s/'//g;
                  $text_str=~s/\n/<\/tr><tr><td>/g;
                  $text_str=~s/===/:<\/td><td>/g;
                  $html_str.="<table width=100% border>";
                  $html_str.="<tr><td>$text_str</td></tr></table>";
         }
    }
    if ( $cginame eq "search.cgi" ) {
         $html_str=${script}.":".${action}." ".${type};
    }
    return "<tt>$html_str</tt>";
}

sub parsess_webmin_log
{
local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq 'stop') {
	return $text{'log_stop'};
	}
elsif ($action eq 'start') {
	return $text{'log_start'};
	}
elsif ($type eq 'db') {
	return &text("log_${type}_${action}", "<tt>$object</tt>");
	}
elsif ($type eq 'table') {
	return &text("log_${type}_${action}", "<tt>$object</tt>",
		     "<tt>$p->{'db'}</tt>");
	}
elsif ($type eq 'field') {
	$p->{'size'} =~ s/\s+$//;
	return &text("log_${type}_${action}", "<tt>$object</tt>",
		     "<tt>$p->{'table'}</tt>", "<tt>$p->{'db'}</tt>",
		     "<tt>$p->{'type'}$p->{'size'}</tt>");
	}
elsif ($type eq 'data') {
	return &text("log_${type}_${action}", "<tt>$object</tt>",
		     "<tt>$p->{'table'}</tt>", "<tt>$p->{'db'}</tt>");
	}
elsif ($action eq 'exec') {
	return &text($long ? 'log_exec_l' : 'log_exec', "<tt>$object</tt>",
		     "<tt>$p->{'cmd'}</tt>");
	}
elsif ($type eq 'user' || $type eq 'perm' || $type eq 'host' ||
       $type eq 'tpriv' || $type eq 'cpriv') {
	$p->{'user'} = $text{'log_anon'}
		if ($p->{'user'} eq '-' || $p->{'user'} eq '%');
	$p->{'db'} = $text{'log_any'}
		if ($p->{'db'} eq '-' || $p->{'db'} eq '%');
	$p->{'host'} = $text{'log_any'}
		if ($p->{'host'} eq '-' || $p->{'host'} eq '%');
	local $t = "log_${type}_${action}";
	if ($long && $text{$t.'_l'}) { $t .= '_l'; }
	return &text($t, "<tt>$p->{'user'}</tt>",
		     "<tt>$p->{'host'}</tt>", "<tt>$p->{'db'}</tt>",
		     "<tt>$p->{'table'}</tt>", "<tt>$p->{'field'}</tt>");
	}
elsif ($action eq 'backup') {
	return &text($long ? 'log_backup_l' : 'log_backup', "<tt>$object</tt>",
		     "<tt>$p->{'file'}</tt>");
	}
elsif ($action eq 'execfile') {
	return &text($p->{'mode'} ? 'log_execupload' : 'log_execfile',
		     "<tt>$p->{'file'}</tt>");
	}
elsif ($action eq 'import') {
	return &text($p->{'mode'} ? 'log_importupload' : 'log_importfile',
		     "<tt>$p->{'file'}</tt>");
	}
else {
	return undef;
	}
}

