# STTA: Introducción

> Esta [Introducción](INTRO-ES.md) fue escrita como parte de la documentación entre 2001-2004.

### Origen y antecedentes.

[Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.) como tecnología permite el acceso optimizado a las aplicaciones corporativas desde muy diferentes condiciones y situaciones. A nadie se le escapa la gran cantidad de "elementos tecnológicos " que han de "combinarse" para conformar un Servicio con [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.). Si miramos cualquier diagrama [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.) aparece "en medio" , el objetivo es que sea completamente transparente y se integre sin provocar grandes cambios en el paradigma de explotación existente, sin embargo a veces se convierte en todo un problema e incluso desvela o revela debilidades del modo actual de trabajo, topología de red, etc.

[Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.) siempre ha sido un producto con gran capacidad de adaptación e integración, el uso de estándares permite muchas posibilidades y combinaciones. El cliente busca una "respuesta", una "solución" global que comprenda todos los aspectos, desde el acceso del usuario, la disponibilidad de aplicaciones, etc pasando por la administración y la extensión de funcionalidades.

[Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.) como empresa se concentra en los aspectos de acceso a aplicaciones y proporcionando mecanismos flexibles para la integración de los "elementos tecnológicos" que formen parte del servicio. Con [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.) la implantación, la combinación de elementos, el modo de explotación se convierte en el factor crítico y definitivo a la hora de crear un "Servicio con [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.)", donde se hace verdad aquello de que cada implantación es un mundo autónomo y distinto, en continuo cambio y transformación.

En definitiva para ofrecer " un modelo operativo con garantías" es necesario:

- Adecuar y sincronizar las tecnologías seleccionadas además de [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.) de modo que "cumplan" estrictamente con los requisitos de explotación planificados. Hay que "combinar", "cortar", etc. Hasta "sincronizar a la medida".
- Ocultar toda complejidad y ofrecer un uso sencillo y transparente y sobre todo práctico para la "producción", para que el "traje a medida" pueda ser usado en el día a día.

Cuando ambas premisas se satisfacen e implementan de acuerdo con las circunstancias y las necesidades se obtiene una respuesta o solución real y ajustada.

A menudo se ha hablado de [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.) como una "caja negra" que proporciona efectos "casi mágicos", pero todos sabemos que estos "trucos" y "efectos" requieren un alto nivel de destreza, sincronización y duro trabajo, porque cada situación es diferente.

### [STTA](README-ES.md): ¿ Por qué una Interface de Gestión más?

El servicio de acceso a las aplicaciones corporativas no está formado por un único elemento tecnológico con único responsable, sino por una combinación de elementos ( Hardware de SUN, Sistema Operativo configurado a medida, Servidores Web, software autenticación, [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.), SSL, etc.), de su correcta sincronización, gestión y disponibilidad depende todo el "servicio de acceso" , de modo que unos dependen y/o se apoyan en otros.

¿ Cómo mantener usuarios en varios servidores de acceso?
¿ Cómo coordinar los usuarios y sus claves con los ya existentes ?
¿ Cómo gestionar usuarios de manera que tengan un perfil de explotación asignado?
¿ Cómo gestionar las claves de acceso de un usuario a cada uno de los servidores de aplicaciones?
¿ Cómo generar copias de los "datos críticos" del servicio de manera "fácil" y "simple"?
¿ Cómo comprobar o controlar qué elemento está fallando dentro del servicio, a modo de supervisión?
¿ Cómo monitorizar y automatizar la explotación limitando y cambiando los accesos en función de la disponibilidad, niveles de respuesta o limitaciones de todos los Servicios?

Es posible colocar bajo una interface los "elementos tecnológicos" que participan en el servicio y proporcionar un entorno fácil que genera y ejecuta las "órdenes necesarias" de forma automática y que guía al operador para evitar errores de sincronización. Además por medio de dicha interface se "establece un modo específico" de operar, parametrizar y definir los "elementos" del Servicio.

### Tencnologías de la Interface [STTA](README-ES.md)

Se basa en "[Webmin](http://www.webmin.com)" una interface para la administración de sistemas operativos Unix, que permite usar un navegador para la gestión del Sistema y de los Servicios que se ejecutan en el mismo. Utiliza un servidor de Web, que puede ser seguro y al que puede restringirse el acceso, junto a programas CGI agrupados en "módulos" según tareas, que están escritos en PERL (un lenguaje de programación GPL). [Webmin](http://www.webmin.com) está disponible bajo licencia BSD, puede ser utilizado y distribuido de modo "libre". (http://www.[Webmin](http://www.webmin.com).com/[Webmin](http://www.webmin.com)/intro.html ). Es como Taratella multiplataforma y mantiene el mismo paradigma de explotación.

El desarrollo es un "nuevo módulo" que accede al Sistema Operativo, a los servicios de LDAP y los de [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.), sincronizando y automatizando todo el trabajo; este módulo está en fuente y está disponible bajo licencia GPL (http://www.gnu.org/philosophy/free-sw.es.html ), por lo que es de uso y distribución libre. También es susceptible de mejoras siempre que se devuelvan con el código fuente.

Cuando un "software" se dice "Free" o "libre" no quiere decir gratuito, o más aún, de escaso valor. Pero al menos uno tiene "el control", "el conocimiento" y " el derecho " de elegir quién, cuándo y cómo

El desarrollo efectuado no ha modificado en absoluto [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.), mediante la interface desarrollada se están automatizando la ejecución de las órdenes de línea de comandos que ya están disponibles en [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.) y en otras herramientas, por ejemplo en el servidor LDAP de iPlanet.

Por ello, si [Tarantella](https://en.wikipedia.org/wiki/Tarantella,_Inc.) cambiara en el futuro la sintaxis de un comando, sólo sería necesario modificar la parte que se ejecuta desde la interface para adaptarse al posible cambio, y esta ha quedado precisamente delimitada en previsión de tal contingencia. De igual forma, si cambiaran comandos del servidor LDAP, habría que efectuar una modificación para adaptarse a esta nueva versión.

[STTA](README-ES.md) es mantenida y soportada vía web, adaptada, instalada e integrada a medida según los trabajos de Consultoría a realizar.
