# STTA Rev. 1.3 Copyright (c) 2001-2003 Jess Prez Lorenzo  --- license GNU GPL
# stta: (@#) 1.31056101209- [2003_06_20_112649]
# help-lib.pl
# changes to manage webminlog sid 


sub write_helpfile
{
  local $dir = $module_name ? "../$_[0]/help" : "$_[0]/help";
  local $path = "$dir/$_[1].$current_lang.html";
  open (FILE, ">$path");
  print FILE "<include head>\n";
  print FILE "<header>$_[1]</header>\n";
  print FILE "<include foot>\n";
  close (FILE);
}

sub open_help_file 
{
    # read the help file
    if ($file =~ /\.html$/) { # it is a full path
        $path = "$root_directory/$module/$file";
    } else {
        $path = &help_file($module, $file);
    }
    @st = stat($path);
    #   open(HELP, $path) || &write_helpfile($module_name,$file);
    open(HELP, $path) || &helperror(&text('help_efile', $path));
    read(HELP, $help, $st[7]);
    close(HELP);
}

sub make_help_html
{
    %infoCfg=();
    # Use config.info to create config inputs
    &read_file("$root_directory/stta/config.info", \%infoCfg);
    foreach $o (@lang_order_list) {
       &read_file("$root_directory/stta/config.info.$o", \%infoCfg);
    }
    &load_more_text('help');  # to make easy translations let us put a lang file
    &load_more_text('cfg');   # load cfg helps
    &load_more_text('feedback');   # load cfg helps
    &read_file("$root_directory/$module_name/dataconf/form_vars", \%text);  # Forms values
    $headImg="";
    $isBook=false;        # this is to make a book, will avoid footlinks 
    $isSection=false;     # this is to ouput other links in includes when in sections
    $isHeadImg=false;     # this is to close table if head image is in use
    $sectionName="";      # this is to keep section name, in some cases change output 
    $isTocBody=false;     # this is to know if index has to be made and adjust foot
   
    local $noHeaderTable=false; # this is to not have too many headers in recursive includes
   
    if ( $WebHelpOut ) { 
         &set_interface_colors();   #  just to be sure !!!
    }
    if ($help =~ /<book\s+(\S+)>/) { $isBook=true; }
    if ($help =~ /<section\s+([^>]*)>/) { $isSection=true; $sectionName=$1 }
    if ($help =~ /<include tocbody>/) { $isTocBody=true; }
    $help =~ s/<section\s+(\S+)>//g;
   
   # find and replace <exec> directives
   $help =~ s/<exec\s+([^>]*)>/exechelp($1)/ge;
   # find and replace %LANG% for lang directory
   $help =~ s/%LANG%/$current_lang/g;
   
   if ( $help =~ /<noheadertable>/) { 
     $help =~ s/<noheadertable>//g;
        $noHeaderTable=true;
   }
   
   $help =~ s/<headimg>([^<]+)<\/headimg>/headimg($1)/ge;
   
   # find and replace the <header> section
   if ($help =~ /<header>([^<]+)<\/header>/) {
       &header($1);
       if ( $help =~ /<headertitle>/) {
            $help =~ s/<header>([^<]+)<\/header>/headtableHelp($1)/ge;
            $help =~ s/<headertitle>(.*)<\/headertitle>/headtitleHelp($1)/eos;
       } else {
            $help =~ s/<header>([^<]+)<\/header>/headtableHelp($1,1)/ge;
       }
   } else {
	   &helperror($text{'help_eheader'});
   }

   if ($help =~ /<book\s+(\S+)>/) {
        local $book=&inchelp($noHeaderTable,$1);
        $book =~ s/<a\s+href="([^>]*)">([^>]*)<\/a><\/li>/setBookLine($1,$2)/ge;
        $help =~ s/<book\s+(\S+)>/$book/g;
   }
   
   # find and replace <if><else> directives
   $help =~ s/<if\s+([^>]*)>([\000-\177]*?)<else>([\000-\177]*?)<\/if>/ifhelp($1, $2, $3)/ge;
   # find and replace <if> directives
   $help =~ s/<if\s+([^>]*)>([\000-\177]*?)<\/if>/ifhelp($1, $2)/ge;

   # find and replace <include> directives
   $help =~ s/<lihelpinc\s+(\S+)\s+(\S+)>/lihelpinc($1,$2)/ge;
   $help =~ s/<include\s+(\S+)>/inchelp($noHeaderTable,$1)/ge;
   $help =~ s/%PREFIX%/ /g;
   
   $help =~ s/<footlinks>(.*)<\/footlinks>/footlinksHelp($1)/eos;
   $help =~ s/<\$out_table{(\S+)}>/infoTable($1)/ge;
   $help =~ s/\$infoCfg{(\S+)}/infoCfg($1)/ge;
   
   $help =~ s/%H%/<img src="\/stta\/images\/icons\/help.gif" border="0" alt="HELP" width="16" height="16">/g;
   $help =~ s/%W%/<img src="\/stta\/images\/icons\/warning.gif" alt="ALERT!" width="16" height="16" border=0>/g;
   $help =~ s/%I%/<img src="\/stta\/images\/icons\/tip.gif" alt="TIP" width="16" height="16"border=0>/g;
   $help =~ s/%N%/<img src="\/stta\/images\/icons\/new.gif" alt="new" width="26" height="8" border=0>/g;
   $help =~ s/%S%/<img src="\/stta\/images\/icons\/starred.gif" alt="starred" width="16" height="16"border=0>/g;
   $help =~ s/%U%/<img src="\/stta\/images\/icons\/updated.gif" alt="updated" width="56" height="8" border=0>/g;
   $help =~ s/%P%/<img src="\/stta\/images\/icons\/pencil.gif" alt="pencil" width="16" height="16" border=0>/g;
   $help =~ s/%AR%/<img src="\/stta\/images\/icons\/arrowright.gif " alt="arrowright" width="16" height="16" border=0>/g;
   $help =~ s/%OK%/<img src="\/stta\/images\/icons\/choice-yes.gif " alt="choice-yes" width="16" height="16" border=0>/g;
   $help =~ s/%INFO%/<img src="\/stta\/images\/info.gif " alt="info" width="20" height="20" border=0>/g;

   if ( $WebHelpOut ) {
        $help =~ s/href="(\S+)"/hrefchange($1)/ge;
        $help =~ s/src="(\S+)"/imgsrcchange($1)/ge;
        $help =~ s/window\.open\("(\S+)"/winOpenUrl($1)/ge;
        $help =~ s/background="(\S+)"/imgbkgchange($1)/ge;
        $help =~ s/href="\/stta\/sttaconfig.cgi"/href="$URLBase\/sttaconfig.html"/g;
        $help =~ s/\/stta\/images\//\/stta\/help\/images\//g;
   }
   $help =~ s/href="(\S+)"/hrefplusquery($1)/ge;
   $help =~ s/%HRTABLE%/hr_table()/ge;
   
   # output the HTML
   #print $help;
   #   &footer();
}
# inchelp(noHeaderTable,path)
sub inchelp
{
	local $ipath = "";

        if ($_[1] =~ /^\/(\S+)/) {
	    # including something from another module..
	    if ( $_[1] =~ /.html$/ ) { 
	         $ipath = "$root_directory/$_[1]";
            } else {
	         $ipath = "$root_directory/$_[1].html";
            }
	} else {
	    # including from this module
	    $ipath = &help_file($module_name, $_[1]);
        }
        my $inc="";
        local $noHeaderTable=$_[0]; # this is to avoid another header output ... too many headers
	@st = stat($ipath);
	open(INC, $ipath) ||
		return "<i>".&text('help_einclude', $ipath)."</i><br>\n";
	read(INC, $inc, $st[7]);
	close(INC);
        # find and replace <if><else> directives
        $inc =~ s/<if\s+([^>]*)>([\000-\177]*?)<else>([\000-\177]*?)<\/if>/ifhelp($1, $2, $3)/ge;
        # find and replace <if> directives
        $inc =~ s/<if\s+([^>]*)>([\000-\177]*?)<\/if>/ifhelp($1, $2)/ge;

        $inc =~ s/<exec\s+([^>]*)>/exechelp($1)/ge;
        $inc =~ s/%LANG%/$current_lang/g;
        $inc =~ s/\$infoCfg{(\S+)}/infoCfg($1)/ge;
        $inc =~ s/<\$out_table{(\S+)}>/infoTable($1)/ge;
        if ($inc =~ /<section\s+([^>]*)>/) { $isSection=true; $sectionName=$1 }
        if ( $noHeaderTable eq true ) {
             $inc =~ s/<headimg>([^<]+)<\/headimg>//ge;
             $inc =~ s/<header>([^<]+)<\/header>/outItemText($1)/ge;
             $inc =~ s/<headertitle>(.*)<\/headertitle>//eos;
        } else {
             $inc =~ s/<headimg>([^<]+)<\/headimg>/headimg($1)/ge;
             if ( $inc =~ /<headertitle>/) {
                    $inc =~ s/<header>([^<]+)<\/header>/headtableHelp($1)/ge;
                    $inc =~ s/<headertitle>(.*)<\/headertitle>/headtitleHelp($1)/eos;
             } else {
                    $inc =~ s/<header>([^<]+)<\/header>/headtableHelp($1,1)/ge;
             }
        }
        if ( $isSection ne "true" && $isTocBody ne "true" ) {
              $inc =~ s/<footlinks>(.*)<\/footlinks>/footlinksHelp($1)/eos;
        } else {
              $inc =~ s/<footlinks>(.*)<\/footlinks>//eos;
        }
        $inc =~ s/<section\s+(\S+)>//g;
        $inc =~ s/<include foot>//g;
        $inc =~ s/<include head>//g;
        # Recursive find and replace <include> directives
        # this is to avoid another header output ... too many headers
        $inc =~ s/<include\s+(\S+)>/inchelp(true,$1)/ge;
        $inc =~ s/<lihelpinc\s+(\S+)\s+(\S+)>/lihelpinc($1,$2)/ge;
	return $inc;
}

# lihelpinc(nroli,npath)
sub lihelpinc
{
        my $inc=&inchelp(true,$_[1]);
        $inc =~ s/%PREFIX%/$_[0] /g;
        $inc =~ s/<lihelpinc\s+(\S+)\s+(\S+)>/lihelpinc($1,$2)/ge;
	return $inc;
}

# ifhelp(perl, text, [elsetext])
sub ifhelp
{
local $rv = eval $_[0];
if ($@) { return "<i>".&text('help_eif', $_[0], $@)."</i><br>\n"; }
elsif ($rv) { return $_[1]; }
else { return $_[2]; }
}

# exechelp(perl)
sub exechelp
{
 my $rv = eval $_[0];
 $rv =~ s/:$//;
 $rv =~ s/:<\/a>$/<\/a>/;
 if ($@) { return "<i>".&text('help_eexec', $_[0], $@)."</i><br>\n"; }
 else { return $rv; }
}

sub helperror
{
if ( $WebHelpOut ) { return }
&header($text{'error'});
print "<center><h2>$text{'error'}</h2></center>\n";
print "<hr><p><b>",@_,"</b><p><hr>\n";
exit;
}

sub outItemText
{
   $item_text=&getItemText($_[0]);
   if (  $isSection eq true && $sectionName ne "" &&  $noHeaderTable eq true ) {
      return "<table border width=100%><tr $cb><td><b><font size=+1>$item_text</font></b></td></tr></table>";
   } else { return "" };
}

sub getItemText
{
   my $item=$_[0];
   my $item_text="";
   if ( $item =~/^f/ ) {   # It is a field ?
             $item=~ s/^f/f_/g;
             $item_text=$text{$item};
             if  ( $item_text eq "" ) {
                   $item = $_[0];
             } else { $item_text =~ s/:$//g;  }
   }
   if ( $item eq $_[0] ) {   # It is title 
             $item="index_".$item;
             $item_text=$text{$item};
             if  ( $item_text eq "" ) { $item = $_[0] }
   }
   if ( $item eq $_[0] ) {   # It something as itself ?
             $item_text=$text{$item} || $_[0];
   }
   return "$item_text";
}

sub headtableHelp
{
   $isHeadImg=false;
   $item_text=&getItemText($_[0]);
   if ( $_[1] ne 1 ) {
     $isHeadImg=true;
     return "<table $tb BORDER=1 width=100%>".
           " <tr><td><table BORDER=1 width=100%><tr><th $tb>$headImg &nbsp;&nbsp;*".
           " <font color=$revtext size=\"+2\">$item_text</font> *</th></tr>";
  } else {
    return "<table $tb BORDER=1 width=100%>".
           " <tr><td><table BORDER=1 width=100%><tr><th $tb>$headImg &nbsp;&nbsp;*&nbsp;&nbsp;".
           "<font color=$revtext size=\"+2\">$item_text</font>&nbsp;&nbsp;*</th></tr>".
           "<tr><td $cb > <br> </td></tr> </table> </td> </tr> </table>";
  }
}
sub headtitleHelp
{
    local $text=$_[0];
    if ( $isHeadImg eq true ) {
         $isHeadImg=false;
         return "<tr><td $cb align=center> <b></b> </td></tr><tr><td $bgimage>$text</td></tr></table></td></tr></table>";
    } else {
         return "<tr><td $cb align=center> <b></b> </td></tr><tr><td $bgimage>$text</td></tr></table>";
    }
    if ( $text =~ /^OPEN / ) {
         $text=~ s/^OPEN //g;
         return "<tr><td $cb align=center> <b>$text</b> </td></tr><tr><td $bgimage>";
    };
    return "<tr><td $cb> $_[0] </td></tr> </table> </td> </tr> </table>";
}
sub footlinksHelp 
{
   local $htmltext;
   if ( $sectionName =~ /toc_/ ) { return ""; }
   if ( $isBook eq true ) { return ""; }
   local @linelinks=split(/::/,$_[0], -1);
   if ( $#linelinks lt 1 ) { return ""; }
   $htmltext="<table $tb BORDER=1 width=100%><tr><td><table BORDER=1 width=100%><tr><td $cb><table><tr>";

   foreach $l (@linelinks) {
        $l =~ s/\r|\n//g;
        if ( $l =~ /<a / ) {
            $htmltext .="<td>$l&nbsp;&nbsp;</td>";
        } else {
            if ( $l =~/^f/ ) {   # It is a field ?
                 $item_text=$l;
                 $item_text=~ s/^f/f_/g;
                 $item_text=$text{$item_text};
            } else { $item_text=$text{$l} }
            if  ( $item_text eq "" ) { $item_text = $l}
            $htmltext .="<td><a href=\"/stta/help.cgi/stta/".$l."\">".$item_text."</a>&nbsp;&nbsp;</td>";
        }
   }
   $htmltext .="</tr></table></td></tr><tr><th $tb><center><font color=$revtext>$text{see_also}</font>".
          "</th></tr></table> </td> </tr> </table>";
   return $htmltext;
}

sub print_table_ordercfgs
{
  local %listfcfgs=(), @ordercfgs=();
  local $item_title, $item_help, $d;
  local $htmltext="";
  local $i=0;
  local $inum="";

     &read_file("$root_directory/$module_name/dataconf/ordercfgs", \%listfcfgs, \@orderfcfgs);
     if ( $_[0] ne "include" && $isBook ne true ) { $htmltext .="<table border=0>\n"; }
     $htmltext .="<ul>\n"; 
     foreach $d (@orderfcfgs) {
         $i++;
         $inum=$i;
         if ( $i < 10 ) { $inum="0".$i; }
         $inum=$_[1].".".$inum; 
         $item_title=$d."_title";
         $item_help=$listfcfgs{$d};
         if ( $_[0] eq "include" || $isBook eq true  ) {
            $htmltext .="<li><table border=0><tr><td valign=center>$inum.- <font>$text{$item_title}</font></td><td align=rigth> - ( <b>$d</b> )&nbsp;</td></tr></table></li>\n";
            $htmltext .= "<hr><p>".&inchelp(false,$item_help)."</p><hr>";
         } else {
            $htmltext .="<tr><td valign=center><li> $inum.-<a href=\"/stta/help.cgi/stta/$item_help\">$text{$item_title}</a></td><td align=rigth> -  <b>$d</b> &nbsp;</li></td></tr>\n";
         }
     }
     $htmltext .="</ul>\n"; 
     if ( $_[0] ne "include" && $isBook ne true ) { $htmltext .="</table>\n"; }
     return $htmltext;
}

sub hrefplusquery
{
   local $href_str=$_[0];
   if ( $querySTR ne "" && $_[0] =~ /\/stta\/help.cgi\/stta/ ) {
         if ( $href_str =~ /\?$querySTR/ ) { return "href=\"$href_str\""; }
         return "href=\"$href_str?$querySTR\"";
   } else {
         return "href=\"$href_str\"";
   }
}

sub hrefchange
{
    local $href_str=$_[0];
    if ( $_[0] =~ /javascript:self.close/ ) {
         $href_str=~ s/javascript:self.close\(\)/$URLBase\//g;
         return "href=\"$href_str\"";
    } elsif ( $_[0] =~ /\/stta\/help.cgi\/stta/ ) {
         $href_str=~ s/\/stta\/help.cgi\/stta/$URLBase/g;
         return "href=\"$href_str.html\"";
    } else {
         return "href=\"$href_str\"";
    }
}
sub imgsrcchange
{
    local $imgsrc_str=$_[0];
    $imgsrc_str=~ s/\/stta\//$IMGBase\//g;
    return "src=\"$imgsrc_str\"";
}
sub imgbkgchange
{
    local $imgbkg_str=$_[0];
    $imgbkg_str=~ s/\/stta\//$IMGBase\//g;
    return "background=\"$imgbkg_str\"";
}
sub headimg
{
    if ( $_[0] ne "flower.gif" ) {
         local @lineimg=split(/ /,$_[0], -1);
         $headImg="<a href=\"$lineimg[0]\"><img border=0 alt=\"$lineimg[1]\" src=\"$lineimg[2]\" ";
         if ( $lineimg[3] gt 0 ) { $headImg .=" width=$lineimg[3]";}
         if ( $lineimg[4] gt 0 ) { $headImg .=" heigth=$lineimg[4]"; }
         $headImg .=" ></a>";
    } else {
         $headImg="<img src=\"/stta/images/flower.gif\" alt=\"Stta\" width=18 height=20 align=\"top\" border=0>";
    }
    return "";
}
sub infoCfg
{
    local $textInfo =  $infoCfg{$_[0]};
    local @lineInfoCfg=split(/,/,$textInfo, -1);
    return "<i>$lineInfoCfg[0]</i>";
}
sub infoTable
{
    local $text= $_[0];
    local %h_objs=&load_tabdef($text);
    $text =~ s/_list//g;
    local $textInfo =  $text{'index_'.$text};
    local $item,$descrip;
    local $outstr="<table BORDER=1 ><tr><th $tb>";
    if ( $sectionName ne "sttatables_def" ) {
         $outstr.=&hlink("<img SRC='/stta/images/info.gif' width=20 heigth=20 align=top border=0>","tableformat");
    }
    $outstr .="*&nbsp;&nbsp;".
           " <font color=$revtext size=\"+2\">".&text("f_tabledef",$textInfo)."</font> *</th></tr>";
    $outstr .="<tr><td><table border=0>\n";
    local @listobjs=();
    foreach $item (keys (%h_objs)) { push (@listobjs,$h_objs{$item}); }
    @listobjs = sort {$a->{'pos'} cmp $b->{'pos'}} @listobjs;
    if ( $#listobjs > 0 ) {
      $outstr.="<tr>"; 
      $outstr.="<td $bgimage align=center>$text{f_pos}</td>"; 
      $outstr.="<td $bgimage align=center>$text{f_alias}</td>"; 
      $outstr.="<td $bgimage align=center>$text{f_namehelp}</td>"; 
      $outstr.="<td $bgimage align=center>$text{f_descrip}</td>"; 
      $outstr.="<td $bgimage align=center>$text{f_range}</td>"; 
      $outstr.="<td $bgimage align=center>$text{f_target}</td>"; 
      $outstr.="<td $bgimage align=center>$text{f_madatory}</td>"; 
      $outstr.="<td $bgimage align=center>$text{f_comments}</td>"; 
      $outstr.="</tr>"; 
    }
    foreach $item (@listobjs) {
      next if ( $item->{alias} eq "" ) ; 
      $outstr.="<tr>"; 
      $outstr.="<td $cb align=center>".$item->{pos}."</td>"; 
      $outstr.="<td $cb>".$item->{alias}."</td>"; 
      $descrip=$text{$item->{name}};
      $descrip =~ s/:$//;
      $outstr.="<td $cb>".&hlink("<b>$descrip</b>",$item->{help})."</td>";
      $outstr.="<td $cb>".$item->{descrip}."</td>"; 
      $outstr.="<td $cb>".$item->{range}."</td>"; 
      $outstr.="<td $cb>".$item->{target}."</td>"; 
      $outstr.="<td $cb align=center>"; 
      if  ( $item->{mandatory} eq "1" ) { $outstr.=$text{yes}; } else { $outstr .= "-" }
      $outstr.="<td $cb>".$item->{comments}."</td>"; 
      $outstr.="</tr>\n"; 
    }
    $outstr.="</table></td></tr></table>\n"; 
    $outstr=~ s/\$infoCfg{(\S+)}/infoCfg($1)/ge;
    $outstr=~ s/\$(\S+){(\S+)}/text_subs($2,\%{$1})/ge;
    return $outstr;
}
sub setBookLine
{
   local @linelink=split(/\//,$_[0], -1);
#   return "<li><font size=+2>$_[1]</font></li><hr>".&inchelp(false,$linelink[$#linelink])."<hr>";
   return "<dd>".&inchelp(false,$linelink[$#linelink])."</dd><hr>";
}

sub winOpenUrl
{
    local $href_str=$_[0];
    if ( $_[0] =~ /\/stta\/help.cgi\/stta/ ) {
         $href_str=~ s/\/stta\/help.cgi\/stta/$URLBase/g;
         return "window.open(\"$href_str.html\"";
    } else {
         return "window.open(\"$href_str\"";
    }
}
sub hr_table
{
  return "<table width=100% align=left border0><tr $cb><td> &nbsp;&nbsp&nbsp;&nbsp</td></tr></table>";
}
1;  # Return true

